Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## swarm.collections
Interface Index

All Known Subinterfaces:
  KeyedCollectionIndex, ListIndex, MapIndex, PermutedIndex

public interface Index
extends DefinedObject, DefinedObjectS, Drop, DropS

Reference into the enumeration sequence for a collection.. An index is a reference into an enumeration sequence of a collection. Such an enumeration sequence contains all members of the collection in some order. This order will always be consistent with ordering of members in the collection, assuming there is such an ordering. Otherwise, the sequence will still contain all members in some order that remains fixed provided that new members are not added or removed from the collection. An index is created by a begin: or createIndex: message against a collection. Each major collection type has its own corresponding index type, which supports specialized types of processing against the valid contents of that kind of collection. Once created, an index is a separate object from the collection itself, but it remains valid only so long as the collection itself still exists. Multiple indexes may exist at the same time against the same collection, and each index maintains its own position within an enumeration sequence for the collection. Many indexes provde the ability modify the collection they refer to, in addition to simply traversing members. An index often provides the complete means for maintaining the contents of a collection, more than could otherwise be performed on the collection itself. The position or other status of the index is automatically updated to reflect any changes made through the index itself. If changes to a collection are made while other indexes exist, those other indexes could be affected in potentially catastrophic ways. Each index is a stand-alone object allocated within a zone passed as an argument in the message that created it. This zone need not match the zone of a collection. It is common for index lifetimes to be shorter than their collection. For example, indexes can be created in a temporary scratch zone for use only within a local loop. Because messages to a collection are the only valid way to create an index, create messages and create-time options are not used with index types. All valid processing on an index is determined by characteristics of the collection from which it is created. Index types are typically named after the type of collection they are created from, and serve principally to define the specific messages valid for an index on that type of collection. Index objects support the universal messages of the top-level DefinedObject supertype, along with the standard drop: and getZone messages. Even though they cannot be created except from a collection, new index objects can be created from an existing index using the standard copy: message. Each copy refers to the same collection as the initial index, and starts at the same position in its enumeration sequence. In all other respects, however, the new copy is an independent index that maintains its own position under any further processing.

Method Summary
`int` | `compare(java.lang.Object anIndex)` The compare: message compares the current location of one index with the current location of another index passed as its argument.
`java.lang.Object` | `findNext(java.lang.Object anObject)` findNext: repeatedly performs next until the member value of the index matches the argument.
`java.lang.Object` | `findPrev(java.lang.Object anObject)` findPrev: repeatedly performs prev until the member value of the index matches the argument.
`java.lang.Object` | `get()` get returns the member value at which the index is currently positioned, or nil if the index is not positioned at a member.
`java.lang.Object` | `getCollection()` getCollection returns the collection referred to by an index.
`Symbol` | `getLoc()` The getLoc message returns a symbol constant which indicates the type of location at which an index is currently positioned.
`int` | `getOffset()` Provided there is no major computational cost, an index also maintains the integer offset of its current member within the enumeration sequence of the collection.
`java.lang.Object` | `next()` The next message positions the index to the next valid member after its current position, or to a special position after the end of all valid members.
`java.lang.Object` | `prev()` The prev message works similarly, but positions to a valid member preceding the current position, or to a special position preceding all valid members.
`java.lang.Object` | `put(java.lang.Object anObject)` The put: message replaces the member value at the current index position with its argument.
`java.lang.Object` | `remove()` The remove message removes the member at the current location of an index, and returns the member value removed.
`void` | `setLoc(Symbol locSymbol)` The setLoc: message may be used to reset the current location of an index to either Start or End.
`java.lang.Object` | `setOffset(int offset)` Using the setOffset: message, an index may be positioned directly to a member using the offset of the member within its enumeration sequence.

Methods inherited from interface swarm.defobj.DefinedObject
`describe, describeID, getDisplayName, getTypeName, getZone, perform, perform$with, perform$with$with, perform$with$with$with, respondsTo, setDisplayName, xfprint, xfprintid, xprint, xprintid`

Methods inherited from interface swarm.defobj.Drop
`drop`

Methods inherited from interface swarm.defobj.GetName
`getName`

Method Detail

### getCollection

    public java.lang.Object getCollection()

  getCollection returns the collection referred to by an index. This collection never changes during the lifetime of the index.

### next

    public java.lang.Object next()

  The next message positions the index to the next valid member after its current position, or to a special position after the end of all valid members. In addition to repositioning the index, both messages return the new member value to which they are positioned, or nil if there is no such member.

### prev

    public java.lang.Object prev()

  The prev message works similarly, but positions to a valid member preceding the current position, or to a special position preceding all valid members.

### findNext

    public java.lang.Object findNext(java.lang.Object anObject)

  findNext: repeatedly performs next until the member value of the index matches the argument. nil is returned if the index reaches the end of valid members without matching the argument.

### findPrev

    public java.lang.Object findPrev(java.lang.Object anObject)

  findPrev: repeatedly performs prev until the member value of the index matches the argument. nil is returned if the index reaches the end of valid members without matching the argument.

### get

    public java.lang.Object get()

  get returns the member value at which the index is currently positioned, or nil if the index is not positioned at a member. The get message provides an alternate way to obtain the current member value in a loop that traverses a collection; its return value is the same as next or prev would return when first positioning to a new member.

### put

    public java.lang.Object put(java.lang.Object anObject)

  The put: message replaces the member value at the current index position with its argument. An InvalidIndexLoc error is raised if the index is not positioned at a current member.

### remove

    public java.lang.Object remove()

  The remove message removes the member at the current location of an index, and returns the member value removed. The index position is set to a special position between the members which previously preceded and followed the removed member. If there is no preceding or following member, the index is set to the special location before the start or after the end of all members. After a current member is removed, there is no member at the current index location, but a subsequent next or prev message will continue with the same member that would have been accessed had the current member not been removed. An InvalidIndexLoc error is raised if the index is not positioned at a current member.

### getLoc

    public Symbol getLoc()

  The getLoc message returns a symbol constant which indicates the type of location at which an index is currently positioned. This index location symbol has one of the following values: Start, End, and Member. The Start symbol indicates the special position preceding all members in the enumeration sequence for the collection. This is the location at which an index is positioned when it is first created. The End symbol indicates the special position following all members in the collection. This is the location at which an index is positioned just after a next message has returned nil, as a result of moving beyond the last member. The Member symbol indicates that the index is positioned at some current member in the enumeration sequence of a collection. The getLoc message is needed to traverse a collection which could contain nil values for its members. Without getLoc, there would be no way to distinguish a nil value returned by next as either a valid member value or the special value returned at the end of members. With getLoc, a loop that traverses a collection can test specifically for the end (or start) of members.

### setLoc

    public void setLoc(Symbol locSymbol)

  The setLoc: message may be used to reset the current location of an index to either Start or End. It may be used to reprocess a collection using an existing index after some other location has already been reached. It may also be used to position an index at the end of all members prior to traversing members in reverse order using prev. Besides Start and End, setLoc: accepts the special argument values of BetweenAfter and BetweenBefore, which are also defined symbols. These argument values are only valid if the index is positioned at a current member. They reposition the index to the special location between the current member and its immediately following or preceding member.

### getOffset

    public int getOffset()

  Provided there is no major computational cost, an index also maintains the integer offset of its current member within the enumeration sequence of the collection. These integer offset values have the same definition as in the atOffset: messages of Collection. The getOffset message returns this current offset value. If the index is current positioned at the Start or End location, getOffset returns -1. If the index is positioned at a Between location, getOffset returns the offset of the immediately preceding member. If the offset is not currently available from the index, getOffset returns the special value UnknownOffset. This value is defined by a macro as the maximally negative value of a 32-bit, 2's-complement integer. An offset is always available from an index if its current position has been reached by repeated operations from an initial Start or End position, and there has been no other modification to the underlying collection. Some forms of direct member access operations supported by some index types, however, may result in an integer offset not being available. These restrictions are noted with the individual index type.

### setOffset

    public java.lang.Object setOffset(int offset)

  Using the setOffset: message, an index may be positioned directly to a member using the offset of the member within its enumeration sequence. The speed of this operation depends on the specific type of the collection, just as noted for the atOffset: message on Collection. In the worst case, this operation is linear in the magnitude of the offset.

### compare

    public int compare(java.lang.Object anIndex)

  The compare: message compares the current location of one index with the current location of another index passed as its argument. If the two indexes have the same location, compare: returns zero. Otherwise, compare: returns +1 or -1 according to whether the argument index precedes or follows the receiver index in the enumeration sequence of the collection. If either of the two indexes has an unknown offset, and the location of the other index is anything other than Start or End or an immediately adjacent member, compare: returns the UnknownOffset integer value.
  Specified by:
    compare in interface DefinedObject

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD